#ifndef SokoInfo_h
#define SokoInfo_h
//-----------------------------------------------------------------------------
// SokoInfo.h
//
//	Application information panel for SokoSave.
//
// Copyright (c), 2001, Eric Sunshine <sunshine@sunshineco.com>
// All rights reserved.
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: SokoInfo.h,v 1.1 2001/12/21 21:46:50 sunshine Exp $
// $Log: SokoInfo.h,v $
// Revision 1.1  2001/12/21 21:46:50  sunshine
// v15
// -*- Extracted core game logic out of GUI code and generalized it so that
//     the same core code can be used by any platform.  Logic from
//     SokoBoard.m now resides in SokoPuzzle.c, etc.
//
// -*- Created a native Windows port of SokoSave using C++Builder.  The
//     back-end logic for this port is provided by the new "sokocore" common
//     code which used to be merged with the UI code for the
//     OpenStep/NextStep ports.  From the user-experience, this port is
//     nearly identical to the existing OpenStep and NextStep ports.  Builds
//     successfully with C++Builder versions 4 and 5.
//
// -*- Added a shortcut toolbar for quickly starting new games, opening saved
//     games, saving games, launching the scores panel, and launching the
//     help file.  Added a toggle-switch to the preferences panel to control
//     presence of toolbar.  From the user-standpoint, this is the only major
//     difference from the OpenStep/NextStep ports, since they do not feature
//     a shortcut toolbar.
//
// -*- Created an InnoSetup installer script for SokoSave.  This scripts
//     facilitates the creation of a stand-alone "setup" program
//     (soksetup.exe) for SokoSave.  With this program, Windows users can
//     download and install SokoSave in a fashion in which they are already
//     familiar.
//
//-----------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <ExtCtrls.hpp>
#include "SokoForm.h"

class TSokoInfoForm : public TSokoForm
    {
__published:
    TImage* app_icon;
    TLabel* app_label;
    TLabel* author_mccarthy;
    TLabel* author_sunshine;
    TLabel* mail_mccarthy;
    TLabel* mail_sunshine;
    TLabel* release_field;
    TLabel* build_field;
    TLabel* copyright_mccarthy;
    TLabel* copyright_sunshine;
    TLabel* web_page;
    TBevel* bevel1;
    TBevel* bevel2;
    void __fastcall form_create( TObject* sender );
    void __fastcall form_close( TObject* sender, TCloseAction& action );
public:
    static void launch();
    __fastcall TSokoInfoForm( TComponent* owner );
    };

extern PACKAGE TSokoInfoForm* SokoInfoForm;

#endif // SokoInfo_h
